var Promise, arrayize, chalk, defaults, filesToLookup, fs, handleThat, isString, merge, ora, path, patternToFiles, prepareFile, readConf;

path = require("path");

merge = require("merge-options");

Promise = require("yaku");

fs = require("fs-extra");

ora = require("ora");

({isString, arrayize, patternToFiles, filesToLookup, prepareFile} = require("./_helper"));

defaults = require("./_defaults");

handleThat = require("handle-that");

chalk = require("chalk");

readConf = require("read-conf");

module.exports = async(config) => {
  var _log, deleted, e, log, print, remaining, spinner, work;
  try {
    if (config == null) {
      config = "chew-away.config";
    }
    if (isString(config)) {
      config = (await readConf(config));
    }
    if (config.mtime == null) {
      config.mtime = 0;
    }
    deleted = {
      lookup: {},
      worker: []
    };
    _log = [];
    log = (i, text) => {
      return (_log[i] != null ? _log[i] : _log[i] = []).push(text);
    };
    print = () => {
      var j, k, len, len1, results, text, texts;
      results = [];
      for (j = 0, len = _log.length; j < len; j++) {
        texts = _log[j];
        for (k = 0, len1 = texts.length; k < len1; k++) {
          text = texts[k];
          console.log(text);
        }
        results.push(console.log(""));
      }
      return results;
    };
    work = (await Promise.all(config.sources.map(async(source, i) => {
      var c, file, input, j, job, k, len, len1, notDeleteLookup, o, outLookup, outName, outfile, output, ref, target;
      o = merge(defaults, config.defaults, source);
      input = (await patternToFiles(o, o.base, log.bind(null, i)));
      output = (await patternToFiles(o, o.target, log.bind(null, i)));
      outLookup = filesToLookup(output);
      notDeleteLookup = {};
      work = [];
      for (j = 0, len = input.length; j < len; j++) {
        file = input[j];
        prepareFile(file, o);
        if (file.chew != null) {
          ref = file.chew;
          for (target in ref) {
            job = ref[target];
            outName = target;
            notDeleteLookup[outName] = true;
            if (o.overwrite || ((outfile = outLookup[outName]) == null) || outfile.mtime < file.mtime || (outfile.mtime < config.mtime && !o.sync)) {
              if (!~work.indexOf(file)) {
                if (o.verbose) {
                  log(i, chalk.cyan(`chew-away: scheduled ${file.name} for chewing`));
                }
                work.push(file);
              }
            } else {
              delete file.chew[target];
              if (o.sync && job[0] === "copy" && (outfile != null) && outfile.mtime > file.mtime) {
                outfile.verbose = o.verbose;
                outfile.sync = o.sync;
                c = outfile.chew = {};
                c[file.name] = job;
                if (o.verbose) {
                  log(i, `chew-away: scheduled ${outfile.path} for chewing backwards`);
                }
                work.push(outfile);
              } else {
                if (o.verbose) {
                  log(i, chalk.green(`chew-away: ${outfile.name} is up-to-date`));
                }
              }
            }
          }
        }
      }
      if (o.excess === "delete") {
        for (k = 0, len1 = output.length; k < len1; k++) {
          outfile = output[k];
          if (!notDeleteLookup[outfile.path] && !deleted.lookup[outfile.path]) {
            if (o.verbose) {
              console.log(`chew-away: ${outfile.path} is gone off`);
            }
            deleted.worker.push(fs.remove(outfile.path));
            deleted.lookup[outfile.path] = true;
          }
        }
      }
      return work;
    })));
    print();
    work = handleThat.flatten(work);
    if (config.test) {
      console.log("chew-away: to chew:");
      work.forEach((file) => {
        var chew, ref, str, target;
        ref = file.chew;
        for (target in ref) {
          chew = ref[target];
          console.log(`${file.name}: ${path.basename(target)}`);
          str = `► ${chew[0]}`;
          if (chew[1] != null) {
            str += ` (${chew[1][0]})`;
          }
          console.log(str);
        }
        return console.log("");
      });
      console.log("chew-away: ======== ");
      console.log("chew-away: exiting ");
      return;
    }
    if ((remaining = work.length) > 0) {
      console.log("chew-away: " + chalk.cyan(`ready to chew away at ${remaining} files`));
      if (deleted.worker.length > 0) {
        console.log("chew-away: " + chalk.magenta(`${deleted.worker.length} files are gone off (deleting)`));
      }
      spinner = ora(`${remaining} files remaining...`).start();
      return handleThat(work, {
        worker: path.resolve(__dirname, "_worker"),
        flatten: false,
        onText: (lines, remaining) => {
          spinner.stop();
          console.log(lines.join("\n"));
          return spinner.start(`${remaining} files remaining...`);
        },
        onProgress: (remaining) => {
          return spinner.text = `${remaining} files remaining...`;
        },
        onFinish: () => {
          return spinner.succeed(chalk.green("pleasantly finished - See you next time! :D"));
        }
      });
    } else {
      return console.log("chew-away: nothing to chew at :*(");
    }
  } catch (error) {
    e = error;
    return console.error(e);
  }
};

if (process.argv[0] === "coffee") {
  module.exports();
}
