var Promise, doubleArrayize, glob, isPlainObject, path;

path = require("path");

glob = require("glob");

Promise = require("yaku");

isPlainObject = require("is-plain-object");

doubleArrayize = (obj) => {
  if (!Array.isArray(obj)) {
    return [[obj]];
  } else if (!Array.isArray(obj[0])) {
    return [obj];
  }
  return obj;
};

module.exports.arrayize = (obj) => {
  if (Array.isArray(obj)) {
    return obj;
  } else if (obj == null) {
    return [];
  } else {
    return [obj];
  }
};

module.exports.isString = (str) => {
  return typeof str === "string" || str instanceof String;
};

module.exports.patternToFiles = (o, cwd, log) => {
  return new Promise((resolve, reject) => {
    var globObj;
    return globObj = glob(o.pattern, {
      cwd: cwd,
      stat: !o.overwrite,
      nodir: true
    }, (err, matches) => {
      var stats, where;
      if (o.verbose) {
        where = o.base === cwd ? "source" : "target";
        log(`chew-away: pattern '${o.pattern}' matched ${matches.length} files in ${where} directory`);
      }
      if (err != null) {
        return reject(err);
      }
      stats = globObj.statCache;
      return resolve(matches.map((filename) => {
        var filepath, s;
        filepath = path.resolve(cwd, filename);
        s = stats[filepath];
        return {
          name: filename,
          path: filepath,
          mtime: s.mtimeMs,
          atime: s.atimeMs
        };
      }));
    });
  });
};

module.exports.filesToLookup = (arr) => {
  return arr.reduce(((acc, current) => {
    acc[current.path] = current;
    return acc;
  }), {});
};

module.exports.prepareFile = (file, o) => {
  var ext, k, obj, out, outpath, ref, tmp, v;
  outpath = path.resolve(o.target, file.name);
  file.verbose = o.verbose;
  file.sync = o.sync;
  ext = file.extIn = path.extname(file.name).slice(1);
  obj = (ref = o.chew) != null ? ref[ext] : void 0;
  if (obj != null) {
    if (!isPlainObject(obj)) {
      tmp = {};
      tmp[ext] = obj;
      obj = tmp;
    } else {
      obj = Object.assign({}, obj);
    }
    for (k in obj) {
      v = obj[k];
      out = outpath;
      if (ext !== k) {
        out = out.replace(ext, k);
      }
      obj[out] = doubleArrayize(v);
      delete obj[k];
    }
    return file.chew = obj;
  }
};
