var cache, chalk, colors, fs, gradient, path, process;

cache = {};

fs = require("fs-extra");

path = require("path");

gradient = require("tinygradient")('#74ebd5', '#74ecd5');

chalk = require("chalk");

process = async(file, target, job) => {
  var clone, e, j, len, method, piece;
  clone = Object.assign({
    target: target
  }, file);
  for (j = 0, len = job.length; j < len; j++) {
    piece = job[j];
    method = piece[0];
    try {
      await (cache[method] != null ? cache[method] : cache[method] = require(`./${method}`))(clone, piece[1]);
    } catch (error) {
      e = error;
      console.error(chalk.red(`Error processing: ${file.name}:`));
      console.error(e);
    }
  }
  if (clone.buffer) {
    await fs.outputFile(clone.target, clone.buffer);
    return file.log(`${path.basename(clone.target)} spat out`);
  }
};

colors = null;

module.exports = (files, nr, length) => {
  return Promise.all(files.map((file, i) => {
    var boundProcess, current, job, ref, subWorkers, target, worker;
    if (length < 2) {
      length = 2;
    }
    if (colors == null) {
      colors = gradient.hsv(length, 'long');
    }
    current = nr + i;
    worker = chalk.hex(colors[current].toHex())(`file ${current + 1}`);
    file.log = (text, level = 0) => {
      if (file.verbose > level) {
        return console.log(`chew-away: ${worker}: ${text}`);
      }
    };
    file.log(`${file.name} sucked in`);
    subWorkers = [];
    boundProcess = process.bind(null, file);
    ref = file.chew;
    for (target in ref) {
      job = ref[target];
      subWorkers.push(boundProcess(target, job));
    }
    return Promise.all(subWorkers).then(() => {
      if (subWorkers.length > 1) {
        return file.log(`all ${subWorkers.length} pieces spat out`);
      }
    });
  }));
};
