var cache, imagemin, path;

imagemin = require("imagemin");

path = require("path");

cache = {};

module.exports = async(file, args) => {
  var plugins;
  if (!Array.isArray(args[0])) {
    args = [args];
  }
  plugins = args.map((plugin) => {
    var name, plg;
    name = plugin[0];
    if ((plg = cache[name]) == null) {
      try {
        plg = require(name);
      } catch (error) {
        try {
          plg = require(path.resolve(process.cwd(), "node_modules", name));
        } catch (error) {
          try {
            plg = require(path.resolve(process.cwd(), "../node_modules", name));
          } catch (error) {
            throw new Error(`couldn't load ${name}`);
          }
        }
      }
      cache[name] = plg;
    }
    return plg(plugin[1]);
  });
  file.log(`scrunching ${file.name} (imagemin)`, 1);
  if (!file.buffer) {
    return (await imagemin([file.name], path.dirname(file.target), {
      plugins: plugins
    }));
  } else {
    return file.buffer = (await imagemin.buffer(file.buffer, {
      plugins: plugins
    }));
  }
};
