var jimp;

jimp = require("jimp");

module.exports = async(file, args) => {
  var chain;
  if (!Array.isArray(args[0])) {
    args = [args];
  }
  args = args.map((cmd) => {
    return cmd.map((prop) => {
      if (jimp[prop]) {
        return jimp[prop];
      } else {
        return prop;
      }
    });
  });
  chain = args.reduce(((current, cmd) => {
    current.then(((cmd, img) => {
      file.log(`chewing on ${file.name} (jimp-${cmd[0]})`, 1);
      return img[cmd.shift()].apply(img, cmd);
    }).bind(null, cmd));
    return current;
  }), jimp.read(file.path));
  return file.buffer = (await chain.then((img) => {
    return new Promise((resolve, reject) => {
      return img.getBuffer(jimp.AUTO, function(err, buffer) {
        if (err != null) {
          return reject(err);
        }
        return resolve(buffer);
      });
    });
  }));
};
